/* Problem URL: https://codeforces.com/edu/course/2/lesson/2/3/practice/contest/269118/problem/A */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

void solve()
{
    string s;
    cin >> s;
    s.push_back('$');

    int n = s.size();

    vi cnt(max(n, 256));
    vi p(n);

    rep(i, n) {
        cnt[s[i]]++;
    }

    nrep(i, 1, cnt.size()) {
        cnt[i] += cnt[i - 1];
    }

    rep(i, n) {
        cnt[s[i]]--;
        p[cnt[s[i]]] = i;
    }

    vi c(n);
    nrep(i, 1, n) {
        c[p[i]] = c[p[i - 1]];
        if (s[p[i]] != s[p[i - 1]]) {
            c[p[i]]++;
        }
    }

    vi pn(n);
    vi cn(n);
    for (int j = 0; (1 << j) < n; j++) {
        rep(i, n) {
            pn[i] = p[i] - (1 << j);
            pn[i] += n * (pn[i] < 0);
        }

        fill(all(cnt), 0);

        rep(i, n) {
            cnt[c[pn[i]]]++;
        }

        nrep(i, 1, cnt.size()) {
            cnt[i] += cnt[i - 1];
        }

        for (int i = n - 1; i >= 0; i--) {
            cnt[c[pn[i]]]--;
            p[cnt[c[pn[i]]]] = pn[i]; 
        }

        cn[p[0]] = 0;
        nrep(i, 1, n) {
            pair<int, int> cur = {c[p[i]], c[(p[i] + (1 << j)) % n]};
            pair<int, int> prev = {c[p[i - 1]], c[(p[i - 1] + (1 << j)) % n]};
            cn[p[i]] = cn[p[i - 1]];
            if (cur != prev) {
                cn[p[i]]++;
            }
        }

        swap(c, cn);
    }

    int q;
    cin >> q;
    while (q--) {
        string a;
        cin >> a;

        int low = 0;
        int high = n - 1;
        int ans = -1;
        while (low <= high) {
            int mid = (low + high) >> 1;

            auto test = [&](string &a) {
                int i = 0;
                while (i < a.size() && i < s.size() && a[i] == s[(i + p[mid]) % n]) {
                    i++;
                }

                if (i == a.size()) {
                    return 0;
                }

                if (i < s.size() && a[i] > s[(i + p[mid]) % n]) {
                    return 1;
                }

                return -1;
            };

            int now = test(a);

            if (now == 0) {
                ans = mid;
                break;
            }

            if (now == 1) {
                low = mid + 1;
                continue;
            }

            high = mid - 1;
        }

        cout << (ans == -1 ? "No\n" : "Yes\n");
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
